---
title: llarp::thread::Queue

---

# llarp::thread::Queue



 [More...](#detailed-description)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[Queue](Classes/classllarp_1_1thread_1_1Queue.md#function-queue)**(size_t capacity) |
| | **[~Queue](Classes/classllarp_1_1thread_1_1Queue.md#function-~queue)**() |
| | **[Queue](Classes/classllarp_1_1thread_1_1Queue.md#function-queue)**(const [Queue](Classes/classllarp_1_1thread_1_1Queue.md) & ) =delete |
| [Queue](Classes/classllarp_1_1thread_1_1Queue.md) & | **[operator=](Classes/classllarp_1_1thread_1_1Queue.md#function-operator=)**(const [Queue](Classes/classllarp_1_1thread_1_1Queue.md) & ) =delete |
| QueueReturn | **[pushBack](Classes/classllarp_1_1thread_1_1Queue.md#function-pushback)**(const Type & value) |
| QueueReturn | **[pushBack](Classes/classllarp_1_1thread_1_1Queue.md#function-pushback)**(Type && value) |
| QueueReturn | **[tryPushBack](Classes/classllarp_1_1thread_1_1Queue.md#function-trypushback)**(const Type & value) |
| QueueReturn | **[tryPushBack](Classes/classllarp_1_1thread_1_1Queue.md#function-trypushback)**(Type && value) |
| Type | **[popFront](Classes/classllarp_1_1thread_1_1Queue.md#function-popfront)**() |
| std::optional< Type > | **[popFrontWithTimeout](Classes/classllarp_1_1thread_1_1Queue.md#function-popfrontwithtimeout)**(std::chrono::microseconds timeout) |
| std::optional< Type > | **[tryPopFront](Classes/classllarp_1_1thread_1_1Queue.md#function-trypopfront)**() |
| void | **[removeAll](Classes/classllarp_1_1thread_1_1Queue.md#function-removeall)**() |
| void | **[disable](Classes/classllarp_1_1thread_1_1Queue.md#function-disable)**() |
| void | **[enable](Classes/classllarp_1_1thread_1_1Queue.md#function-enable)**() |
| size_t | **[capacity](Classes/classllarp_1_1thread_1_1Queue.md#function-capacity)**() const |
| size_t | **[size](Classes/classllarp_1_1thread_1_1Queue.md#function-size)**() const |
| bool | **[enabled](Classes/classllarp_1_1thread_1_1Queue.md#function-enabled)**() const |
| bool | **[full](Classes/classllarp_1_1thread_1_1Queue.md#function-full)**() const |
| bool | **[empty](Classes/classllarp_1_1thread_1_1Queue.md#function-empty)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| constexpr size_t | **[Alignment](Classes/classllarp_1_1thread_1_1Queue.md#variable-alignment)**  |

## Detailed Description

```cpp
template <typename Type >
class llarp::thread::Queue;
```

## Public Functions Documentation

### function Queue

```cpp
explicit Queue(
    size_t capacity
)
```


### function ~Queue

```cpp
~Queue()
```


### function Queue

```cpp
Queue(
    const Queue & 
) =delete
```


### function operator=

```cpp
Queue & operator=(
    const Queue & 
) =delete
```


### function pushBack

```cpp
QueueReturn pushBack(
    const Type & value
)
```


### function pushBack

```cpp
QueueReturn pushBack(
    Type && value
)
```


### function tryPushBack

```cpp
QueueReturn tryPushBack(
    const Type & value
)
```


### function tryPushBack

```cpp
QueueReturn tryPushBack(
    Type && value
)
```


### function popFront

```cpp
Type popFront()
```


### function popFrontWithTimeout

```cpp
std::optional< Type > popFrontWithTimeout(
    std::chrono::microseconds timeout
)
```


### function tryPopFront

```cpp
std::optional< Type > tryPopFront()
```


### function removeAll

```cpp
void removeAll()
```


### function disable

```cpp
void disable()
```


### function enable

```cpp
void enable()
```


### function capacity

```cpp
size_t capacity() const
```


### function size

```cpp
size_t size() const
```


### function enabled

```cpp
bool enabled() const
```


### function full

```cpp
bool full() const
```


### function empty

```cpp
bool empty() const
```


## Public Attributes Documentation

### variable Alignment

```cpp
static constexpr size_t Alignment = 64;
```


-------------------------------

Updated on 2023-01-31 at 18:48:38 +0000