---
title: llarp::ILinkManager

---

# llarp::ILinkManager





Inherited by [llarp::LinkManager](Classes/structllarp_1_1LinkManager.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual | **[~ILinkManager](Classes/structllarp_1_1ILinkManager.md#function-~ilinkmanager)**() =default |
| virtual LinkLayer_ptr | **[GetCompatibleLink](Classes/structllarp_1_1ILinkManager.md#function-getcompatiblelink)**(const [RouterContact](Classes/structllarp_1_1RouterContact.md) & rc) const =0 |
| virtual [IOutboundSessionMaker](Classes/structllarp_1_1IOutboundSessionMaker.md) * | **[GetSessionMaker](Classes/structllarp_1_1ILinkManager.md#function-getsessionmaker)**() const =0 |
| virtual bool | **[SendTo](Classes/structllarp_1_1ILinkManager.md#function-sendto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote, const [llarp_buffer_t](Classes/structllarp__buffer__t.md) & buf, [ILinkSession::CompletionHandler](Classes/structllarp_1_1ILinkSession.md#using-completionhandler) completed, uint16_t priority =0) =0 |
| virtual bool | **[HasSessionTo](Classes/structllarp_1_1ILinkManager.md#function-hassessionto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote) const =0 |
| virtual bool | **[HasOutboundSessionTo](Classes/structllarp_1_1ILinkManager.md#function-hasoutboundsessionto)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote) const =0 |
| virtual std::optional< bool > | **[SessionIsClient](Classes/structllarp_1_1ILinkManager.md#function-sessionisclient)**([RouterID](Classes/structllarp_1_1RouterID.md) remote) const =0<br>return true if the session with this pubkey is a client return false if the session with this pubkey is a router return std::nullopt we have no session with this pubkey  |
| virtual void | **[PumpLinks](Classes/structllarp_1_1ILinkManager.md#function-pumplinks)**() =0 |
| virtual void | **[AddLink](Classes/structllarp_1_1ILinkManager.md#function-addlink)**(LinkLayer_ptr link, bool inbound =false) =0 |
| virtual bool | **[StartLinks](Classes/structllarp_1_1ILinkManager.md#function-startlinks)**() =0 |
| virtual void | **[Stop](Classes/structllarp_1_1ILinkManager.md#function-stop)**() =0 |
| virtual void | **[PersistSessionUntil](Classes/structllarp_1_1ILinkManager.md#function-persistsessionuntil)**(const [RouterID](Classes/structllarp_1_1RouterID.md) & remote, llarp_time_t until) =0 |
| virtual void | **[ForEachPeer](Classes/structllarp_1_1ILinkManager.md#function-foreachpeer)**(std::function< void(const [ILinkSession](Classes/structllarp_1_1ILinkSession.md) *, bool)> visit, bool randomize =false) const =0 |
| virtual void | **[ForEachPeer](Classes/structllarp_1_1ILinkManager.md#function-foreachpeer)**(std::function< void([ILinkSession](Classes/structllarp_1_1ILinkSession.md) *)> visit) =0 |
| virtual void | **[ForEachInboundLink](Classes/structllarp_1_1ILinkManager.md#function-foreachinboundlink)**(std::function< void(LinkLayer_ptr)> visit) const =0 |
| virtual void | **[ForEachOutboundLink](Classes/structllarp_1_1ILinkManager.md#function-foreachoutboundlink)**(std::function< void(LinkLayer_ptr)> visit) const =0 |
| virtual void | **[DeregisterPeer](Classes/structllarp_1_1ILinkManager.md#function-deregisterpeer)**([RouterID](Classes/structllarp_1_1RouterID.md) remote) =0<br>close all connections to this peer remove all link layer commits  |
| virtual size_t | **[NumberOfConnectedRouters](Classes/structllarp_1_1ILinkManager.md#function-numberofconnectedrouters)**() const =0 |
| virtual size_t | **[NumberOfConnectedClients](Classes/structllarp_1_1ILinkManager.md#function-numberofconnectedclients)**() const =0 |
| virtual size_t | **[NumberOfPendingConnections](Classes/structllarp_1_1ILinkManager.md#function-numberofpendingconnections)**() const =0 |
| virtual bool | **[GetRandomConnectedRouter](Classes/structllarp_1_1ILinkManager.md#function-getrandomconnectedrouter)**([RouterContact](Classes/structllarp_1_1RouterContact.md) & router) const =0 |
| virtual void | **[CheckPersistingSessions](Classes/structllarp_1_1ILinkManager.md#function-checkpersistingsessions)**(llarp_time_t now) =0 |
| virtual void | **[updatePeerDb](Classes/structllarp_1_1ILinkManager.md#function-updatepeerdb)**(std::shared_ptr< [PeerDb](Classes/structllarp_1_1PeerDb.md) > peerDb) =0 |
| virtual util::StatusObject | **[ExtractStatus](Classes/structllarp_1_1ILinkManager.md#function-extractstatus)**() const =0 |

## Public Functions Documentation

### function ~ILinkManager

```cpp
virtual ~ILinkManager() =default
```


### function GetCompatibleLink

```cpp
virtual LinkLayer_ptr GetCompatibleLink(
    const RouterContact & rc
) const =0
```


**Reimplemented by**: [llarp::LinkManager::GetCompatibleLink](Classes/structllarp_1_1LinkManager.md#function-getcompatiblelink)


### function GetSessionMaker

```cpp
virtual IOutboundSessionMaker * GetSessionMaker() const =0
```


**Reimplemented by**: [llarp::LinkManager::GetSessionMaker](Classes/structllarp_1_1LinkManager.md#function-getsessionmaker)


### function SendTo

```cpp
virtual bool SendTo(
    const RouterID & remote,
    const llarp_buffer_t & buf,
    ILinkSession::CompletionHandler completed,
    uint16_t priority =0
) =0
```


**Reimplemented by**: [llarp::LinkManager::SendTo](Classes/structllarp_1_1LinkManager.md#function-sendto)


### function HasSessionTo

```cpp
virtual bool HasSessionTo(
    const RouterID & remote
) const =0
```


**Reimplemented by**: [llarp::LinkManager::HasSessionTo](Classes/structllarp_1_1LinkManager.md#function-hassessionto)


### function HasOutboundSessionTo

```cpp
virtual bool HasOutboundSessionTo(
    const RouterID & remote
) const =0
```


**Reimplemented by**: [llarp::LinkManager::HasOutboundSessionTo](Classes/structllarp_1_1LinkManager.md#function-hasoutboundsessionto)


### function SessionIsClient

```cpp
virtual std::optional< bool > SessionIsClient(
    RouterID remote
) const =0
```

return true if the session with this pubkey is a client return false if the session with this pubkey is a router return std::nullopt we have no session with this pubkey 

**Reimplemented by**: [llarp::LinkManager::SessionIsClient](Classes/structllarp_1_1LinkManager.md#function-sessionisclient)


### function PumpLinks

```cpp
virtual void PumpLinks() =0
```


**Reimplemented by**: [llarp::LinkManager::PumpLinks](Classes/structllarp_1_1LinkManager.md#function-pumplinks)


### function AddLink

```cpp
virtual void AddLink(
    LinkLayer_ptr link,
    bool inbound =false
) =0
```


**Reimplemented by**: [llarp::LinkManager::AddLink](Classes/structllarp_1_1LinkManager.md#function-addlink)


### function StartLinks

```cpp
virtual bool StartLinks() =0
```


**Reimplemented by**: [llarp::LinkManager::StartLinks](Classes/structllarp_1_1LinkManager.md#function-startlinks)


### function Stop

```cpp
virtual void Stop() =0
```


**Reimplemented by**: [llarp::LinkManager::Stop](Classes/structllarp_1_1LinkManager.md#function-stop)


### function PersistSessionUntil

```cpp
virtual void PersistSessionUntil(
    const RouterID & remote,
    llarp_time_t until
) =0
```


**Reimplemented by**: [llarp::LinkManager::PersistSessionUntil](Classes/structllarp_1_1LinkManager.md#function-persistsessionuntil)


### function ForEachPeer

```cpp
virtual void ForEachPeer(
    std::function< void(const ILinkSession *, bool)> visit,
    bool randomize =false
) const =0
```


**Reimplemented by**: [llarp::LinkManager::ForEachPeer](Classes/structllarp_1_1LinkManager.md#function-foreachpeer)


### function ForEachPeer

```cpp
virtual void ForEachPeer(
    std::function< void(ILinkSession *)> visit
) =0
```


**Reimplemented by**: [llarp::LinkManager::ForEachPeer](Classes/structllarp_1_1LinkManager.md#function-foreachpeer)


### function ForEachInboundLink

```cpp
virtual void ForEachInboundLink(
    std::function< void(LinkLayer_ptr)> visit
) const =0
```


**Reimplemented by**: [llarp::LinkManager::ForEachInboundLink](Classes/structllarp_1_1LinkManager.md#function-foreachinboundlink)


### function ForEachOutboundLink

```cpp
virtual void ForEachOutboundLink(
    std::function< void(LinkLayer_ptr)> visit
) const =0
```


**Reimplemented by**: [llarp::LinkManager::ForEachOutboundLink](Classes/structllarp_1_1LinkManager.md#function-foreachoutboundlink)


### function DeregisterPeer

```cpp
virtual void DeregisterPeer(
    RouterID remote
) =0
```

close all connections to this peer remove all link layer commits 

**Reimplemented by**: [llarp::LinkManager::DeregisterPeer](Classes/structllarp_1_1LinkManager.md#function-deregisterpeer)


### function NumberOfConnectedRouters

```cpp
virtual size_t NumberOfConnectedRouters() const =0
```


**Reimplemented by**: [llarp::LinkManager::NumberOfConnectedRouters](Classes/structllarp_1_1LinkManager.md#function-numberofconnectedrouters)


### function NumberOfConnectedClients

```cpp
virtual size_t NumberOfConnectedClients() const =0
```


**Reimplemented by**: [llarp::LinkManager::NumberOfConnectedClients](Classes/structllarp_1_1LinkManager.md#function-numberofconnectedclients)


### function NumberOfPendingConnections

```cpp
virtual size_t NumberOfPendingConnections() const =0
```


**Reimplemented by**: [llarp::LinkManager::NumberOfPendingConnections](Classes/structllarp_1_1LinkManager.md#function-numberofpendingconnections)


### function GetRandomConnectedRouter

```cpp
virtual bool GetRandomConnectedRouter(
    RouterContact & router
) const =0
```


**Reimplemented by**: [llarp::LinkManager::GetRandomConnectedRouter](Classes/structllarp_1_1LinkManager.md#function-getrandomconnectedrouter)


### function CheckPersistingSessions

```cpp
virtual void CheckPersistingSessions(
    llarp_time_t now
) =0
```


**Reimplemented by**: [llarp::LinkManager::CheckPersistingSessions](Classes/structllarp_1_1LinkManager.md#function-checkpersistingsessions)


### function updatePeerDb

```cpp
virtual void updatePeerDb(
    std::shared_ptr< PeerDb > peerDb
) =0
```


**Reimplemented by**: [llarp::LinkManager::updatePeerDb](Classes/structllarp_1_1LinkManager.md#function-updatepeerdb)


### function ExtractStatus

```cpp
virtual util::StatusObject ExtractStatus() const =0
```


**Reimplemented by**: [llarp::LinkManager::ExtractStatus](Classes/structllarp_1_1LinkManager.md#function-extractstatus)


-------------------------------

Updated on 2023-01-31 at 18:48:37 +0000