---
title: llarp/tooling/hive_context.hpp

---

# llarp/tooling/hive_context.hpp



## Namespaces

| Name           |
| -------------- |
| **[tooling](Namespaces/namespacetooling.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[tooling::HiveContext](Classes/structtooling_1_1HiveContext.md)** <br>[HiveContext]() is a subclass of llarp::Context which allows [RouterHive]() to perform custom behavior which might be undesirable in production code.  |




## Source code

```cpp
#pragma once

#include <llarp.hpp>
#include "hive_router.hpp"

namespace tooling
{
  struct HiveContext : public llarp::Context
  {
    HiveContext(RouterHive* hive);

    std::shared_ptr<llarp::AbstractRouter>
    makeRouter(const llarp::EventLoop_ptr& loop) override;

    HiveRouter*
    getRouterAsHiveRouter();

   protected:
    RouterHive* m_hive = nullptr;
  };

}  // namespace tooling
```


-------------------------------

Updated on 2023-01-31 at 18:48:38 +0000
