---
title: llarp/routing/path_transfer_message.hpp

---

# llarp/routing/path_transfer_message.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::routing](Namespaces/namespacellarp_1_1routing.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::routing::PathTransferMessage](Classes/structllarp_1_1routing_1_1PathTransferMessage.md)**  |




## Source code

```cpp
#pragma once

#include <llarp/crypto/encrypted.hpp>
#include <llarp/crypto/types.hpp>
#include "message.hpp"
#include <llarp/service/protocol.hpp>

namespace llarp
{
  namespace routing
  {
    struct PathTransferMessage final : public IMessage
    {
      PathID_t P;
      service::ProtocolFrame T;
      TunnelNonce Y;

      PathTransferMessage() = default;
      PathTransferMessage(const service::ProtocolFrame& f, const PathID_t& p) : P(p), T(f)
      {
        Y.Randomize();
      }
      ~PathTransferMessage() override = default;

      bool
      DecodeKey(const llarp_buffer_t& key, llarp_buffer_t* val) override;

      bool
      BEncode(llarp_buffer_t* buf) const override;

      bool
      HandleMessage(IMessageHandler*, AbstractRouter* r) const override;

      void
      Clear() override
      {
        P.Zero();
        T.Clear();
        Y.Zero();
        version = 0;
      }
    };

  }  // namespace routing
}  // namespace llarp
```


-------------------------------

Updated on 2023-01-31 at 18:48:38 +0000
